#ifndef DECODEUR_H
#define DECODEUR_H

#include "interface.h"

// Décode les PGN des messages NMEA2000 de la station WSO100 (cf. doc) :
// 130311 (2 trames / s)
// 130306 (10 trames / s)

//#define DEBUG_DECODEUR

class DecodeurNMEA2000
{
   public:     
      static double extraireTemperature(const BYTE DATA[8]);
      static double extrairePressionAtmospherique(const BYTE DATA[8]);
      static double extraireHygrometrie(const BYTE DATA[8]);
      static double extraireVitesseVent(const BYTE DATA[8]);
      static double extraireDirectionVent(const BYTE DATA[8]); 
 
   //private:
      DecodeurNMEA2000();
      ~DecodeurNMEA2000();      
};

#endif
