#ifndef MESURES_H
#define MESURES_H

#include "interface.h"
#include <vector>
#include <algorithm>
#include <iomanip>

#define NB_MAXIMUM_MESURES 10

//#define DEBUG_MESURES

class Mesures
{
   public:
      Mesures();
      ~Mesures();
       
      bool   estPlein() const ;    
      double getTemperature();
      double getPressionAtmospherique();
      double getHygrometrie();
      double getVitesseVent();
      double getDirectionVent();
      void   reinitialiser();
      void   ajouterMesuresEnvironnement(double temperature, double pressionAtmospherique, double hygrometrie);
      void   ajouterMesuresVent(double vitesseVent, double directionVent);
      
      void trierMesuresEnvironnement(); 
      void trier(vector<double> &t);
      bool estTrie(const vector<double> &t) const;
      void extraireMediane();
      void extraireMax();
      
      friend ostream& operator<<(ostream &sortie, const Mesures &m);
 
   private:
      vector<double> temperatures;
      vector<double> pressionsAtmospheriques;
      vector<double> hygrometries;
      vector<double> vitessesVent;
      vector<double> directionsVent;
      double temperature;
      double pressionAtmospherique;
      double hygrometrie;
      double vitesseVent;
      double directionVent;
};

#endif
