#include <cppunit/config/SourcePrefix.h>

#include "TestUnitaireMesures.h"
#include "mesures.h" // Classe  tester

// Enregistrement des diffrents cas de tests
CPPUNIT_TEST_SUITE_REGISTRATION( TestUnitaireMesures );

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TestUnitaireMesures::TestUnitaireMesures()
{

}

TestUnitaireMesures::~TestUnitaireMesures()
{

}

void TestUnitaireMesures::setUp() 
{
   // Initialisation pour les tests
   mesures = new Mesures;   
}

void TestUnitaireMesures::tearDown() 
{
   delete mesures;
}

void TestUnitaireMesures::testTriTaillePaire()
{
	// Initialisation du test
   const int NB_ELT = 6;
	vector<double> temperatures(NB_ELT);
	
	temperatures[0] = 58;
	temperatures[1] = 4;
	temperatures[2] = 69;
	temperatures[3] = 158;
	temperatures[4] = 88;
	temperatures[5] = 27;

   // Appel mthode teste (lancement)
   mesures->trier(temperatures);

   // Vrification des rsultats attendus
   // Le tableau doit tre tri
   CPPUNIT_ASSERT_EQUAL( true, mesures->estTrie(temperatures) );
   
   // Technique dtaille :
   bool resultatObtenu;
   bool resultatAttendu = true;   
   
   resultatObtenu = mesures->estTrie(temperatures);
   CPPUNIT_ASSERT_MESSAGE( "classe valide : le vector doit tre tri (taille paire)", resultatObtenu == resultatAttendu);
   // ou : CPPUNIT_ASSERT_EQUAL_MESSAGE(message, expected, actual);
   CPPUNIT_ASSERT_EQUAL( resultatAttendu, mesures->estTrie(temperatures) ); 
   // ou :
   //CPPUNIT_ASSERT( mesures->estTrie() == resultatAttendu );
}

void TestUnitaireMesures::testTriTailleImpaire()
{
   // Initialisation du test
   const int NB_ELT = 3;
   vector<double> temperatures(NB_ELT);
   
   temperatures[0] = 69;
   temperatures[1] = 58;
   temperatures[2] = 4;

   // Appel mthode teste (lancement)
   mesures->trier(temperatures);

   // Vrification des rsultats attendus
   // Le tableau doit tre tri
   CPPUNIT_ASSERT_EQUAL( true, mesures->estTrie(temperatures) );
}

void TestUnitaireMesures::testTriDejaTrie()
{
	// Initialisation du test
	const int NB_ELT = 4;
	vector<double> temperatures(NB_ELT);
	
	temperatures[0] = 4;
	temperatures[1] = 85;
	temperatures[2] = 99;
	temperatures[3] = 150;
	
   // Appel mthode teste (lancement)
   mesures->trier(temperatures);

   // Vrification des rsultats attendus
   // Le tableau doit tre tri
   CPPUNIT_ASSERT_EQUAL( true, mesures->estTrie(temperatures) );
}

// TODO : etc ...
